package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.GameRefereeBo;
import org.dromara.system.domain.vo.GameRefereeVo;
import org.dromara.system.domain.GameReferee;
import org.dromara.system.mapper.GameRefereeMapper;
import org.dromara.system.service.IGameRefereeService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 裁判Service业务层处理
 *
 * @author zlt
 * @date 2025-07-30
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class GameRefereeServiceImpl implements IGameRefereeService {

    private final GameRefereeMapper baseMapper;

    /**
     * 查询裁判
     *
     * @param refereeId 主键
     * @return 裁判
     */
    @Override
    public GameRefereeVo queryById(Long refereeId){
        return baseMapper.selectVoById(refereeId);
    }

    /**
     * 分页查询裁判列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 裁判分页列表
     */
    @Override
    public TableDataInfo<GameRefereeVo> queryPageList(GameRefereeBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<GameReferee> lqw = buildQueryWrapper(bo);
        Page<GameRefereeVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的裁判列表
     *
     * @param bo 查询条件
     * @return 裁判列表
     */
    @Override
    public List<GameRefereeVo> queryList(GameRefereeBo bo) {
        LambdaQueryWrapper<GameReferee> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<GameReferee> buildQueryWrapper(GameRefereeBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<GameReferee> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(GameReferee::getRefereeId);
        lqw.eq(bo.getEventId() != null, GameReferee::getEventId, bo.getEventId());
        lqw.like(StringUtils.isNotBlank(bo.getName()), GameReferee::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), GameReferee::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增裁判
     *
     * @param bo 裁判
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(GameRefereeBo bo) {
        GameReferee add = MapstructUtils.convert(bo, GameReferee.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setRefereeId(add.getRefereeId());
        }
        return flag;
    }

    /**
     * 修改裁判
     *
     * @param bo 裁判
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(GameRefereeBo bo) {
        GameReferee update = MapstructUtils.convert(bo, GameReferee.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(GameReferee entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除裁判信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
